#include <stdio.h>

#define CRC32_POLYNOMIAL 0x04c11db7

void Initialize( );
unsigned int FullCRC( unsigned char *sData, unsigned int ulLength );
void PartialCRC( unsigned int *ulInCRC, unsigned char *sData, unsigned int ulLength );

unsigned int Reflect( unsigned int ulReflect, char cChar );
unsigned int ulTable[256];

void Initialize() 
{
    int iCodes,iPos;
    for(iCodes = 0; iCodes <= 0xFF; iCodes++ ) {
	ulTable[iCodes] = Reflect( iCodes, 8 ) << 24;
	for(iPos = 0; iPos < 8; iPos++ )
	    ulTable[iCodes] = ( ulTable[iCodes] << 1 ) ^ 
	    ( (ulTable[iCodes] & 0x80000000) ? CRC32_POLYNOMIAL : 0 );
	ulTable[iCodes] = Reflect( ulTable[iCodes], 32 );
    }
}

unsigned int Reflect( unsigned int ulReflect, char cChar )
{
    unsigned int ulValue = 0;
    int iPos;
    for( iPos = 1; iPos < ( cChar + 1 ); iPos++ ) {
	if( ulReflect & 1 )
	    ulValue |= 1 << ( cChar - iPos );
	ulReflect >>= 1;
    }
    return ulValue;
}

unsigned int FullCRC( unsigned char *sData, unsigned int ulLength )
{
    unsigned int ulCRC = 0xFFFFFFFF;
    PartialCRC( &ulCRC, sData, ulLength );
    return ulCRC ^ 0xFFFFFFFF;
}

void PartialCRC( unsigned int *ulInCRC, unsigned char *sData, unsigned int ulLength )
{
    while( ulLength-- )
	*ulInCRC = ( *ulInCRC >> 8 ) ^ ulTable[( *ulInCRC & 0xFF ) ^ *sData++];
}

int main(){
    int i;
    Initialize();
    for(i=0; i<256; i++){
      printf("0x%08X,",ulTable[i]);
      if((i % 8)==7) printf("\n");
    }
    return 0;
}
